/**
 ** worldModelGrid3DGExecCodels.cc
 **
 ** Codels called by execution task worldModelGrid3DGExec
 **
 ** Author: NAKHAEI Alireza
 ** Date:  29/10/07
 **
 **/


#include <portLib.h>

#include "server/worldModelGrid3DGHeader.h"
#include "worldModelGrid3D/wmGrid3D.h"


#include "stereopixelClient.h"

#include "pomStruct.h"


# include "t3d/v3d.h"
# include "t3d/t3d.h"
#ifdef __cplusplus
extern "C"
{
#endif
# include "libimages3d.h"
#ifdef __cplusplus
};
#endif


#if DEBUG==2
#define ODEBUG2(x) std::cout << "worldModelGrid3D-genom:" << x << std::endl
#define ODEBUG1(x) std::cerr << "worldModelGrid3D-genom:" << x << std::endl
#elif DEBUG==1
#define ODEBUG2(x)
#define ODEBUG1(x) std::cerr << "worldModelGrid3D-genom:" << x << std::endl
#else
#define ODEBUG2(x)
#define ODEBUG1(x)
#endif



#define SP_POSTER_ENABLE 0
#define LIB_IMAGE_3D 0
#define BOOST_3D 1

/*stereoPixel*/
static POSTER_ID spixPosterId;		/* current 3d image poster */
static Spix3DImage *spixImage;		/* current poster addr */

using namespace::std;
//using namespace::WorldModel3D;

CwmGrid3D attwmGrid3D;


static void updateWorldModelPosters()
{
	SDI_F->grid3DMap.map3DResolution=attwmGrid3D.getResolution();
	box_area mapVolume= attwmGrid3D.getMapVolume();
	SDI_F->grid3DMap.map3DBoxArea.xStart=mapVolume.xstart;
	SDI_F->grid3DMap.map3DBoxArea.yStart=mapVolume.ystart;
	SDI_F->grid3DMap.map3DBoxArea.zStart=mapVolume.zstart;
	SDI_F->grid3DMap.map3DBoxArea.xEnd=mapVolume.xend;
	SDI_F->grid3DMap.map3DBoxArea.yEnd=mapVolume.yend;
	SDI_F->grid3DMap.map3DBoxArea.zEnd=mapVolume.zend;

	//==================   Updating the SDIF parameters for updating the poster
	int NbOfGrid = attwmGrid3D.getMapXN() * attwmGrid3D.getMapYN() * attwmGrid3D.getMapZN();
	SDI_F->grid3DMap.nbOfGridX=attwmGrid3D.getMapXN();
	SDI_F->grid3DMap.nbOfGridY=attwmGrid3D.getMapYN();
	SDI_F->grid3DMap.nbOfGridZ=attwmGrid3D.getMapZN();
	grid *inGridMap = attwmGrid3D.getGridMap();

	//==================  setting the "grid3DMap[].gridvalue": Free =0, Solid(Obstacle) =1, Unknown =2
	int inNbFree=0;
	int inNbSolid=0;
	int inNbUnknown=0;
	
	//==================  Analyse the result: the gratest is the status
	for ( int i=0; i < NbOfGrid; i++ )
	{
		if ( inGridMap[i].odd > UNKNOWN_MAX )
		{
			SDI_F->grid3DMap.gridvalue[i]=1;
			inNbSolid++;
		}
		else
		{
			if ( ( inGridMap[i].odd >=UNKNOWN_MIN ) && ( inGridMap[i].odd<=UNKNOWN_MAX ) )
			{
				SDI_F->grid3DMap.gridvalue[i]=2;
				inNbUnknown++;
			}
			else
			{
				SDI_F->grid3DMap.gridvalue[i]=0;
				inNbFree++;
			}
		}
	}

	cout << "Report - worldModelGrid3D-Genom :"<< endl;
	cout << "Number of grid = "<< inNbUnknown + inNbSolid +inNbFree<< endl;
	cout << "Unknown = "<< inNbUnknown << endl;
	cout << "UnSolid = "<< inNbSolid << endl;
	cout << "UnFree = "<< inNbFree << endl;

	SDI_F->updateFlag = 1;
}
/*------------------------------------------------------------------------
 *
 * sampleExecInit  --  Initialization codel (fIDS, ...)
 *
 * Description:
 *
 * Returns:    OK or ERROR
 */

STATUS
sampleExecInit ( int *report )
{
	/* ... add your code here ... */

	return OK;
}

/*------------------------------------------------------------------------
 *
 * sampleExecEnd  --  Termination codel
 *
 * Description:
 *
 * Returns:    OK or ERROR
 */

STATUS
sampleExecEnd ( void )
{
	return OK;
}

/*------------------------------------------------------------------------
 *
 * sampleExecPerm  --  codel of permanent activity
 *
 * Description:
 *
 * Reports:      OK
 *
 * Returns:    OK or ERROR
 */

STATUS
sampleExecPerm ( int *report )
{
	/* ... add your code here ... */
	return OK;
}
/*------------------------------------------------------------------------
 * Initialize
 *
 * Description:
 *
 * Reports:      OK
 *              S_worldModelGrid3DG_INITIALIZATION_FAILURE
 */

/* worldModelGrid3DGInitialize  -  codel EXEC of Initialize
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
worldModelGrid3DGInitialize ( int *updateNumber, int *report )
{
	SDI_F->updateNumber = *updateNumber;
	SDI_F->updateFlag = 0;
	// Initializing the STEREOPIXEL
#if SP_POSTER_ENABLE // By using the poster of stereo pixle
	fprintf ( stderr, "looking for poster " STEREOPIXEL_3DIMAGE_POSTER_NAME "\n" );
	if ( posterFind ( STEREOPIXEL_3DIMAGE_POSTER_NAME, &spixPosterId ) != OK )
	{
		spixImage = NULL;
		fprintf ( stderr,
		          "poster " STEREOPIXEL_3DIMAGE_POSTER_NAME " not found, using 2D only.\n" );
		*report=S_worldModelGrid3DG_INITIALIZATION_FAILURE;

	}
	else
		spixImage = ( Spix3DImage * ) posterAddr ( spixPosterId );
#endif
	return ETHER;
}

/*------------------------------------------------------------------------
 * SetResolution
 *
 * Description:
 *
 * Reports:      OK
 *              S_worldModelGrid3DG_SETTING_RESOLUTION_FAILURE
 */

/* worldModelGrid3DGSetResolution  -  codel EXEC of SetResolution
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
worldModelGrid3DGSetResolution ( double *resolution, int *report )
{
	SDI_F->grid3DMap.map3DResolution=*resolution;

	if ( attwmGrid3D.setResolution ( *resolution ) !=WM_OK )
	{
		*report=S_worldModelGrid3DG_SETTING_RESOLUTION_FAILURE;
		return FAIL;
	}

	return ETHER;
}

/*------------------------------------------------------------------------
 * SetSensitivity
 *
 * Description:
 *
 * Reports:      OK
 *              S_worldModelGrid3DG_SETTING_SENSITIVITY_FAILURE
 */

/* worldModelGrid3DGSetSensitivity  -  codel EXEC of SetSensitivity
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
worldModelGrid3DGSetSensitivity ( unsigned int *sensitivity, int *report )
{
	if ( attwmGrid3D.setSensitivity ( *sensitivity ) !=WM_OK )
	{
		*report=S_worldModelGrid3DG_SETTING_SENSITIVITY_FAILURE;
		return FAIL;
	}

	return ETHER;
}

/*------------------------------------------------------------------------
 * SetCameraParameters
 *
 * Description:
 *
 * Reports:      OK
 *              S_worldModelGrid3DG_SETTING_CAMERA_PARAMETERS_FAILURE
 */

/* worldModelGrid3DGSetCameraParameters  -  codel EXEC of SetCameraParameters
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
worldModelGrid3DGSetCameraParameters ( vec3 *cameraParameters, int *report )
{
	if ( attwmGrid3D.setCameraParameters ( cameraParameters->widthAngle,cameraParameters->heightAngle,cameraParameters->observableDistance ) !=WM_OK )
	{
		*report=S_worldModelGrid3DG_SETTING_CAMERA_PARAMETERS_FAILURE;
		return FAIL;
	}

	return ETHER;
}

/*------------------------------------------------------------------------
 * AllocateMap
 *
 * Description:
 *
 * Reports:      OK
 *              S_worldModelGrid3DG_ALLOCATING_MAP_FAILURE
 */

/* worldModelGrid3DGAllocateMap  -  codel EXEC of AllocateMap
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
worldModelGrid3DGAllocateMap ( boxArea *mapArea, int *report )
{
// Update the SDIF Parametr
	SDI_F->grid3DMap.map3DBoxArea=*mapArea;

	if ( attwmGrid3D.allocateMap ( mapArea->xStart,mapArea->yStart,mapArea->zStart, mapArea->xEnd,mapArea->yEnd,mapArea->zEnd ) !=WM_OK )
	{
		*report=S_worldModelGrid3DG_ALLOCATING_MAP_FAILURE;
		return FAIL;
	}

	return ETHER;
}
/*------------------------------------------------------------------------
* SetFreeBox
*
* Description:
*
* Reports:      OK
*              S_worldModelGrid3DG_SETTING_FREE_BOX_FAILURE
*/

/* worldModelGrid3DGSetFreeBox  -  codel EXEC of SetFreeBox
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
worldModelGrid3DGSetFreeBox ( boxArea *freeBox, int *report )
{

	if ( attwmGrid3D.setFreeBox ( freeBox->xStart,freeBox->yStart,freeBox->zStart, freeBox->xEnd,freeBox->yEnd,freeBox->zEnd ) !=WM_OK )
	{
		*report= S_worldModelGrid3DG_SETTING_FREE_BOX_FAILURE;
		return FAIL;
	}
	return ETHER;
}

/*------------------------------------------------------------------------
 * MakeBoxFree
 *
 * Description:
 *
 * Reports:      OK
 *              S_worldModelGrid3DG_MAKING_FREE_BOX_FAILURE
 */

/* worldModelGrid3DGMakeBoxFree  -  codel EXEC of MakeBoxFree
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
worldModelGrid3DGMakeBoxFree ( boxArea *box, int *report )
{
	if ( attwmGrid3D.makeBoxFree ( box->xStart,box->yStart,box->zStart, box->xEnd,box->yEnd,box->zEnd ) !=WM_OK )
	{
		*report= S_worldModelGrid3DG_MAKING_FREE_BOX_FAILURE;
		return FAIL;
	}
	
	updateWorldModelPosters();
	return ETHER;
}

/*------------------------------------------------------------------------
 * MakeBoxSolid
 *
 * Description:
 *
 * Reports:      OK
 *              S_worldModelGrid3DG_MAKING_SOLID_BOX_FAILURE
 */

/* worldModelGrid3DGMakeBoxSolid  -  codel EXEC of MakeBoxSolid
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
worldModelGrid3DGMakeBoxSolid ( boxArea *box, int *report )
{
	if ( attwmGrid3D.makeBoxSolid ( box->xStart,box->yStart,box->zStart, box->xEnd,box->yEnd,box->zEnd ) !=WM_OK )
	{
		*report= S_worldModelGrid3DG_MAKING_SOLID_BOX_FAILURE;
		return FAIL;
	}
	updateWorldModelPosters();

	return ETHER;
}

/*------------------------------------------------------------------------
 * Update3DMap
 *
 * Description:
 *
 * Reports:      OK
 *              S_worldModelGrid3DG_UPDATING_MAP_FAILURE
 */

/* worldModelGrid3DGUpdate3DMap  -  codel EXEC of Update3DMap
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
worldModelGrid3DGUpdate3DMap ( imageRange *imageID, int *report )
{
//==================   1. Setting Sensor position
#if SP_POSTER_ENABLE // By using the poster of stereo pixle

	ODEBUG2 ( "start of worldModelGrid3DGUpdate3DMap  -  Using StereoPixel Poster" );
	if ( posterTake ( spixPosterId, POSTER_READ ) != OK )
	{
		//*report = errnoGet();
		*report = S_worldModelGrid3DG_UPDATING_MAP_FAILURE;
		ODEBUG1 ( "Error: in Taking the poster of steroPixel" );

		return FAIL;
	}
#if BOOST_3D
	ODEBUG2 ( "Using BOOST library." );
	ODEBUG2 ( "Getting sensor position." );

	boost::numeric::ublas::matrix<float> inSensorPosition1 ( 4,4 ),inSensorPosition2 ( 4,4 ), sensorToMain ( 4,4 ), mainToOrigin ( 4,4 ), cameraToSensor ( 4,4 );

	// setting The Matrix of MainToOrigin(Global position of the Robot)
	double inYaw, inPitch, inRoll, inX, inY, inZ;
	inYaw = spixImage->imagePos.mainToOrigin.euler.yaw;
	inPitch = spixImage->imagePos.mainToOrigin.euler.pitch;
	inRoll = spixImage->imagePos.mainToOrigin.euler.roll;
	inX = spixImage->imagePos.mainToOrigin.euler.x;
	inY = spixImage->imagePos.mainToOrigin.euler.y;
	inZ = spixImage->imagePos.mainToOrigin.euler.z;

	ODEBUG2 ( "mainToOrigin -> " << inYaw << ", "<<inPitch<< " , " << inRoll<< " , "<< inX << ", "<< inY <<", "<< inZ );

	mainToOrigin ( 0,0 ) =cos ( inYaw ) *cos ( inPitch );
	mainToOrigin ( 0,1 ) =cos ( inYaw ) *sin ( inPitch ) *sin ( inRoll )-sin ( inYaw ) *cos ( inRoll );
	mainToOrigin ( 0,2 ) =cos ( inYaw ) *sin ( inPitch ) *cos ( inRoll ) +sin ( inYaw ) *sin ( inRoll );
	mainToOrigin ( 0,3 ) =inX;
	mainToOrigin ( 1,0 ) =sin ( inYaw ) *cos ( inPitch );
	mainToOrigin ( 1,1 ) =sin ( inYaw ) *sin ( inPitch ) *sin ( inRoll ) +cos ( inYaw ) *cos ( inRoll );
	mainToOrigin ( 1,2 ) =sin ( inYaw ) *sin ( inPitch ) *cos ( inRoll )-cos ( inYaw ) *sin ( inRoll );
	mainToOrigin ( 1,3 ) =inY;
	mainToOrigin ( 2,0 ) =-sin ( inPitch );
	mainToOrigin ( 2,1 ) =cos ( inPitch ) *sin ( inRoll );
	mainToOrigin ( 2,2 ) =cos ( inPitch ) *cos ( inRoll );
	mainToOrigin ( 2,3 ) =inZ;
	mainToOrigin ( 3,0 ) =0;
	mainToOrigin ( 3,1 ) =0;
	mainToOrigin ( 3,2 ) =0;
	mainToOrigin ( 3,3 ) =1;

	if ( attwmGrid3D.setRobotBoxPos ( inX, inY, inYaw ) !=WM_OK )
	{
		*report = S_worldModelGrid3DG_UPDATING_MAP_FAILURE;
		ODEBUG1 ( "Error: worldModelGrid-Genom:: UpdateMap: in setRobotBoxPos" );
		return FAIL;
	}

	// setting The Matrix of sensorToMain(local position of the sensor regarding the robot position)
	inYaw = spixImage->imagePos.sensorToMain.euler.yaw;
	inPitch = spixImage->imagePos.sensorToMain.euler.pitch;
	inRoll = spixImage->imagePos.sensorToMain.euler.roll;
	inX = spixImage->imagePos.sensorToMain.euler.x;
	inY = spixImage->imagePos.sensorToMain.euler.y;
	inZ = spixImage->imagePos.sensorToMain.euler.z;
	ODEBUG2 ( "SensorToMain -> " << inYaw << ", "<<inPitch<< " , " << inRoll<< " , "<< inX << ", "<< inY <<", "<< inZ );

	sensorToMain ( 0,0 ) =cos ( inYaw ) *cos ( inPitch );
	sensorToMain ( 0,1 ) =cos ( inYaw ) *sin ( inPitch ) *sin ( inRoll )-sin ( inYaw ) *cos ( inRoll );
	sensorToMain ( 0,2 ) =cos ( inYaw ) *sin ( inPitch ) *cos ( inRoll ) +sin ( inYaw ) *sin ( inRoll );
	sensorToMain ( 0,3 ) =inX;
	sensorToMain ( 1,0 ) =sin ( inYaw ) *cos ( inPitch );
	sensorToMain ( 1,1 ) =sin ( inYaw ) *sin ( inPitch ) *sin ( inRoll ) +cos ( inYaw ) *cos ( inRoll );
	sensorToMain ( 1,2 ) =sin ( inYaw ) *sin ( inPitch ) *cos ( inRoll )-cos ( inYaw ) *sin ( inRoll );
	sensorToMain ( 1,3 ) =inY;
	sensorToMain ( 2,0 ) =-sin ( inPitch );
	sensorToMain ( 2,1 ) =cos ( inPitch ) *sin ( inRoll );
	sensorToMain ( 2,2 ) =cos ( inPitch ) *cos ( inRoll );
	sensorToMain ( 2,3 ) =inZ;
	sensorToMain ( 3,0 ) =0;
	sensorToMain ( 3,1 ) =0;
	sensorToMain ( 3,2 ) =0;
	sensorToMain ( 3,3 ) =1;

// updating Camera to sensor coordintae
	float yaw3, pitch3,roll3, xx3 , yy3 , zz3;
	yaw3 =-1* M_PI/2;
	pitch3 = 0;
	roll3 = -1*M_PI/2;
	xx3=0;
	yy3=0;
	zz3=0;

	cameraToSensor ( 0,0 ) =cos ( yaw3 ) *cos ( pitch3 );
	cameraToSensor ( 0,1 ) =cos ( yaw3 ) *sin ( pitch3 ) *sin ( roll3 )-sin ( yaw3 ) *cos ( roll3 );
	cameraToSensor ( 0,2 ) =cos ( yaw3 ) *sin ( pitch3 ) *cos ( roll3 ) +sin ( yaw3 ) *sin ( roll3 );
	cameraToSensor ( 0,3 ) =xx3;
	cameraToSensor ( 1,0 ) =sin ( yaw3 ) *cos ( pitch3 );
	cameraToSensor ( 1,1 ) =sin ( yaw3 ) *sin ( pitch3 ) *sin ( roll3 ) +cos ( yaw3 ) *cos ( roll3 );
	cameraToSensor ( 1,2 ) =sin ( yaw3 ) *sin ( pitch3 ) *cos ( roll3 )-cos ( yaw3 ) *sin ( roll3 );
	cameraToSensor ( 1,3 ) =yy3;
	cameraToSensor ( 2,0 ) =-sin ( pitch3 );
	cameraToSensor ( 2,1 ) =cos ( pitch3 ) *sin ( roll3 );
	cameraToSensor ( 2,2 ) =cos ( pitch3 ) *cos ( roll3 );
	cameraToSensor ( 2,3 ) =zz3;
	cameraToSensor ( 3,0 ) =0;
	cameraToSensor ( 3,1 ) =0;
	cameraToSensor ( 3,2 ) =0;
	cameraToSensor ( 3,3 ) =1;

	inSensorPosition1 = boost::numeric::ublas::prod ( mainToOrigin,sensorToMain );
	inSensorPosition2 = boost::numeric::ublas::prod ( inSensorPosition1,cameraToSensor );

	if ( attwmGrid3D.setSensorPosition ( inSensorPosition2 ) !=WM_OK )
	{
		*report = S_worldModelGrid3DG_UPDATING_MAP_FAILURE;
		ODEBUG1 ( "Error: worldModelGrid-Genom:: UpdateMap: in SetSensorPosition" );
		return FAIL;
	}

//==================   2. Getting the 3D Image
	ODEBUG2 ( "Getting 3D image information." );

	int i, j;
	Spix3DPixel *src= spixImage->pixel;

	int imageWidth = spixImage->width;
	int imageHeight = spixImage->height;
	int inNbOfPixel = imageWidth*imageHeight;
	ODEBUG2 ( "imWidth = " << imageWidth );
	ODEBUG2 ( "imHeight = " << imageHeight );
	ODEBUG2 ( " inNbOfPixel-before = " << inNbOfPixel );
	boost::numeric::ublas::matrix<float> inRangeMap ( inNbOfPixel,4 );
	for ( i=0; i<imageHeight; i++ )
	{
		for ( j=0; j<imageWidth; j++ )
		{
			int good= src->good;
			if ( good==1 )
			{
				inRangeMap ( i*imageWidth+j,0 ) = src->x;
				inRangeMap ( i*imageWidth+j,1 ) = src->y;
				inRangeMap ( i*imageWidth+j,2 ) = src->z;
// 				inRangeMap ( i*imageWidth+j,0 ) = src->z;
// 				inRangeMap ( i*imageWidth+j,1 ) = -1 * src->x;
// 				inRangeMap ( i*imageWidth+j,2 ) = -1 * src->y;
				inRangeMap ( i*imageWidth+j,3 ) = src->sigma;
			}
			else
			{
				inRangeMap ( i*imageWidth+j,0 ) =-1;
				inRangeMap ( i*imageWidth+j,1 ) =-1;
				inRangeMap ( i*imageWidth+j,2 ) =-1;
				inRangeMap ( i*imageWidth+j,3 ) =1;
			}
			src++;
		}
	}
	posterGive ( spixPosterId );

	if ( attwmGrid3D.setRangeMap ( inRangeMap ) !=WM_OK )
	{
		*report = S_worldModelGrid3DG_UPDATING_MAP_FAILURE;
		cout << "Error: worldModelGrid-Genom:: UpdateMap: in setRangeMap" << endl;
		return FAIL;

	}

	if ( attwmGrid3D.updateMap () !=WM_OK )
	{
		*report = S_worldModelGrid3DG_UPDATING_MAP_FAILURE;
		cout << "Error: worldModelGrid-Genom:: UpdateMap: in updateMap" << endl;
		return FAIL;

	}
#endif //end of using boost by poster
#endif // end of algorithm for using the Poster of StereoPixel
//============================================================================================================
#if !SP_POSTER_ENABLE // Test: For reading the pre-generated Textfile of stereopixel
#if BOOST_3D
	ODEBUG2 ( "USING BOOST in GENOM WorlModelGrid3D Test Version" );
	for ( int updateNb= ( imageID->startNumber ); updateNb < ( imageID->endNumber ); updateNb=updateNb+1 )
	{
		char* point3DFileTemp="/home/anakhaei/images/3Dimage02/im3dc.";
		//char* point3DFileTemp="/home/anakhaei/imageTest/Position3D/im3dc.";

		// The address of the files of the pixel 3DPosition
		char* point3DFile;

		// The address of the files that of the Sensor Position
		char* sensorPositionFile;

		sensorPositionFile= "/home/anakhaei/images/serie02/image.pos.";
		point3DFile="/home/anakhaei/images/3Dimage02/im3d.";

		char buffName1[100];
		char buffName2[100];
		char buffName3[100];
		char buffName4[100];
		char buffName5[150];
		char buffName6[150];
		char command1[150];
		char command2[150];
		char command3[150];
		sprintf ( buffName1, "%s%04d", sensorPositionFile, updateNb );
		ODEBUG2 ( "buffName1 = " <<buffName1 );

		sprintf ( buffName6, "%s%s", buffName1, ".g" );
		ODEBUG2 ( "buffName6 = " <<buffName6 );

		sprintf ( buffName2, "%s%04d", point3DFile, updateNb );

		ODEBUG2 ( "buffName2 = " <<buffName2 );

		sprintf ( buffName3, "%s%s", buffName2, ".gz" );

		ODEBUG2 ( "buffName3 = " <<buffName3 );

		sprintf ( buffName4, "%s%04d", point3DFileTemp, updateNb );

		ODEBUG2 ( "buffName4 = " <<buffName4 );

		sprintf ( buffName5, "%s%s", buffName4,".gz" );

		ODEBUG2 ( "buffName5 = " <<buffName5 );

		sprintf ( command1, "%s%s%s%s", "cp ", buffName3," ", buffName5 );

		ODEBUG2 ( "command1 = " <<command1 );

		sprintf ( command2, "%s%s", "gzip -df ",buffName5 );
		ODEBUG2 ( "command2 = " <<command2 );

		sprintf ( command3, "%s%s", "rm -rf -r ",buffName4 );
		ODEBUG2 ( "command3 = " <<command3 );

		//make a copy
		system ( command1 );
		system ( command2 );

// == 2 . updating the sensor pisition
		float yaw1, pitch1 ,roll1, xx1 , yy1 , zz1;
		float yaw2, pitch2,roll2, xx2 , yy2 , zz2;
		float yaw3, pitch3,roll3, xx3 , yy3 , zz3;
		string lines[6],word1;
		char word2;
		ifstream myfile ( buffName6 );
		ODEBUG2 ( "Sensor file address : " << buffName6 );
		if ( myfile.is_open() )
		{
			unsigned int i = 0;
			while ( !myfile.eof() )
			{
				getline ( myfile,lines[i] );
				i++;
			}
		}
		myfile.close();
		istringstream stream;
		boost::numeric::ublas::matrix<float> inSensorPosition1 ( 4,4 ),inSensorPosition2 ( 4,4 ),cameraToSensor ( 4,4 ), sensorToMain ( 4,4 ), mainToOrigin ( 4,4 );

// using Robot Global Position
		ODEBUG2 ( "Setting Main to Origin (Robot Global Position)" );
		stream.str ( lines[4] );

		stream >>word1;
		stream >> word2;

		stream >> yaw1 >> pitch1 >> roll1 >> xx1 >> yy1 >> zz1;

		ODEBUG2 ( "yaw1 = " << yaw1 <<", pitch1= " << pitch1 << ", roll1= "<< roll1 <<",  xx1=  " << xx1 <<", yy1="<< yy1 <<", zz1= "<< zz1 );

		mainToOrigin ( 0,0 ) = cos ( yaw1 ) *cos ( pitch1 );
		mainToOrigin ( 0,1 ) = cos ( yaw1 ) *sin ( pitch1 ) *sin ( roll1 )-sin ( yaw1 ) *cos ( roll1 );
		mainToOrigin ( 0,2 ) = cos ( yaw1 ) *sin ( pitch1 ) *cos ( roll1 ) +sin ( yaw1 ) *sin ( roll1 );
		mainToOrigin ( 0,3 ) = xx1;
		mainToOrigin ( 1,0 ) = sin ( yaw1 ) *cos ( pitch1 );
		mainToOrigin ( 1,1 ) = sin ( yaw1 ) *sin ( pitch1 ) *sin ( roll1 ) +cos ( yaw1 ) *cos ( roll1 );
		mainToOrigin ( 1,2 ) = sin ( yaw1 ) *sin ( pitch1 ) *cos ( roll1 )-cos ( yaw1 ) *sin ( roll1 );
		mainToOrigin ( 1,3 ) = yy1;
		mainToOrigin ( 2,0 ) = -sin ( pitch1 );
		mainToOrigin ( 2,1 ) = cos ( pitch1 ) *sin ( roll1 );
		mainToOrigin ( 2,2 ) = cos ( pitch1 ) *cos ( roll1 );
		mainToOrigin ( 2,3 ) = zz1;
		mainToOrigin ( 3,0 ) =0;
		mainToOrigin ( 3,1 ) =0;
		mainToOrigin ( 3,2 ) =0;
		mainToOrigin ( 3,3 ) =1;

		if ( attwmGrid3D.setRobotBoxPos ( xx1, yy1, yaw1 ) !=WM_OK )
		{
			*report = S_worldModelGrid3DG_UPDATING_MAP_FAILURE;
			ODEBUG1 ( "Error: worldModelGrid-Genom:: UpdateMap: in setRobotBoxPos" );
			return FAIL;
		}


// using sensor Local Position
		stream.str ( lines[2] );

		stream >>word1;
		stream >> word2;
		stream >> yaw2 >> pitch2 >> roll2 >> xx2 >> yy2 >> zz2;

		ODEBUG2 ( "yaw2 = " << yaw2 <<", pitch2= " << pitch2 << ", roll2= "<< roll2 <<",  xx2=  " << xx2 <<", yy2="<< yy2 <<", zz2= "<< zz2 );

		sensorToMain ( 0,0 ) =cos ( yaw2 ) *cos ( pitch2 );
		sensorToMain ( 0,1 ) =cos ( yaw2 ) *sin ( pitch2 ) *sin ( roll2 )-sin ( yaw2 ) *cos ( roll2 );
		sensorToMain ( 0,2 ) =cos ( yaw2 ) *sin ( pitch2 ) *cos ( roll2 ) +sin ( yaw2 ) *sin ( roll2 );
		sensorToMain ( 0,3 ) =xx2;
		sensorToMain ( 1,0 ) =sin ( yaw2 ) *cos ( pitch2 );
		sensorToMain ( 1,1 ) =sin ( yaw2 ) *sin ( pitch2 ) *sin ( roll2 ) +cos ( yaw2 ) *cos ( roll2 );
		sensorToMain ( 1,2 ) =sin ( yaw2 ) *sin ( pitch2 ) *cos ( roll2 )-cos ( yaw2 ) *sin ( roll2 );
		sensorToMain ( 1,3 ) =yy2;
		sensorToMain ( 2,0 ) =-sin ( pitch2 );
		sensorToMain ( 2,1 ) =cos ( pitch2 ) *sin ( roll2 );
		sensorToMain ( 2,2 ) =cos ( pitch2 ) *cos ( roll2 );
		sensorToMain ( 2,3 ) =zz2;
		sensorToMain ( 3,0 ) =0;
		sensorToMain ( 3,1 ) =0;
		sensorToMain ( 3,2 ) =0;
		sensorToMain ( 3,3 ) =1;

// updating Camera to sensor coordintae
		yaw3 =-1* M_PI/2;
		pitch3 = 0;
		roll3 = -1*M_PI/2;
		xx3=0;
		yy3=0;
		zz3=0;

		cameraToSensor ( 0,0 ) =cos ( yaw3 ) *cos ( pitch3 );
		cameraToSensor ( 0,1 ) =cos ( yaw3 ) *sin ( pitch3 ) *sin ( roll3 )-sin ( yaw3 ) *cos ( roll3 );
		cameraToSensor ( 0,2 ) =cos ( yaw3 ) *sin ( pitch3 ) *cos ( roll3 ) +sin ( yaw3 ) *sin ( roll3 );
		cameraToSensor ( 0,3 ) =xx3;
		cameraToSensor ( 1,0 ) =sin ( yaw3 ) *cos ( pitch3 );
		cameraToSensor ( 1,1 ) =sin ( yaw3 ) *sin ( pitch3 ) *sin ( roll3 ) +cos ( yaw3 ) *cos ( roll3 );
		cameraToSensor ( 1,2 ) =sin ( yaw3 ) *sin ( pitch3 ) *cos ( roll3 )-cos ( yaw3 ) *sin ( roll3 );
		cameraToSensor ( 1,3 ) =yy3;
		cameraToSensor ( 2,0 ) =-sin ( pitch3 );
		cameraToSensor ( 2,1 ) =cos ( pitch3 ) *sin ( roll3 );
		cameraToSensor ( 2,2 ) =cos ( pitch3 ) *cos ( roll3 );
		cameraToSensor ( 2,3 ) =zz3;
		cameraToSensor ( 3,0 ) =0;
		cameraToSensor ( 3,1 ) =0;
		cameraToSensor ( 3,2 ) =0;
		cameraToSensor ( 3,3 ) =1;

		inSensorPosition1 = boost::numeric::ublas::prod ( mainToOrigin,sensorToMain );
		inSensorPosition2 = boost::numeric::ublas::prod ( inSensorPosition1,cameraToSensor );

		if ( attwmGrid3D.setSensorPosition ( inSensorPosition2 ) !=WM_OK )
		{
			*report = S_worldModelGrid3DG_UPDATING_MAP_FAILURE;
			ODEBUG1 ( "Error: worldModelGrid-Genom:: UpdateMap: in SetSensorPosition" );
			return FAIL;
		}

// == 3 . updating the 3D position
		char * fileName = buffName4;
		float data[9];
		boost::numeric::ublas::matrix<float> inRangeMap;
		int NbOfPixel;
		string line,lineTemp[8];
		ifstream myfile2 ( fileName );
		ODEBUG2 ( "fileName = " <<fileName );

		if ( myfile2.is_open() )
		{
			istringstream stream;
			for ( int i=0; i<8; i++ )
			{
				getline ( myfile2,lineTemp[i] );
			}
			stream.str ( lineTemp[3] );
			stream >> data[0] >> data[1] >> data[2] >>  data[3];
			int imageCurrentWidth=data[3];
			int imageCurrentHeight=data[2];
			NbOfPixel=imageCurrentHeight*imageCurrentWidth;

			//For considerin covariance we use 4 cullumn
			inRangeMap.resize ( NbOfPixel,4 );
			for ( int i=0; i<imageCurrentHeight; i++ )
			{
				getline ( myfile2,line );
				stream.str ( line );
				for ( int j=0; j<imageCurrentWidth; j++ )
				{
					stream >> data[0] >> data[1] >>  data[2] >>  data[3] >>  data[4] >> data[5] >> data[6]  >> data[7] >>  data[8];
					if ( data[0]==1 )
					{
						inRangeMap ( i*imageCurrentWidth+j,0 ) =data[6];
						inRangeMap ( i*imageCurrentWidth+j,1 ) =data[7];
						inRangeMap ( i*imageCurrentWidth+j,2 ) =data[8];
						inRangeMap ( i*imageCurrentWidth+j,3 ) =0.0002;
					}
					else
					{
						inRangeMap ( i*imageCurrentWidth+j,0 ) =-1;
						inRangeMap ( i*imageCurrentWidth+j,1 ) =-1;
						inRangeMap ( i*imageCurrentWidth+j,2 ) =-1;
						inRangeMap ( i*imageCurrentWidth+j,2 ) =1;
					}
				}
			}
		}
		myfile2.close();
		if ( attwmGrid3D.setRangeMap ( inRangeMap ) !=WM_OK )
		{
			*report = S_worldModelGrid3DG_UPDATING_MAP_FAILURE;
			ODEBUG1 ( "Error: worldModelGrid-Genom:: UpdateMap: in setRangeMap" );
			return FAIL;

		}
		if ( attwmGrid3D.updateMap () !=WM_OK )
		{
			*report = S_worldModelGrid3DG_UPDATING_MAP_FAILURE;
			ODEBUG1 ( "Error: worldModelGrid-Genom:: UpdateMap: in updateMap" );
			return FAIL;

		}
		system ( command3 );
	}
#endif // end of using BOOST

#if LIB_IMAGE_3D  // for using the libImage 3D library
	ODEBUG2 ( "Using libImage3d for updating rangeMap and sensor Position in WorldModel3D Genom Test Version" );
	for ( int updateNb= ( imageID->startNumber ); updateNb < ( imageID->endNumber ); updateNb=updateNb+1 )
	{
		ODEBUG2 ( "Process(LIB-IM-3D) photo "<< updateNb );
		char* point3DFileTemp="/home/anakhaei/images/3Dimage02/im3dc.";
		//char* point3DFileTemp="/home/anakhaei/imageTest/Position3D/im3dc.";

		// The address of the files of the pixel 3DPosition
		char* point3DFile;

		// The address of the files that of the Sensor Position
		char* sensorPositionFile;

		sensorPositionFile= "/home/anakhaei/images/serie02/image.pos.";
		point3DFile="/home/anakhaei/images/3Dimage02/im3d.";

		char buffName1[100];
		char buffName2[100];
		char buffName3[100];
		char buffName4[100];
		char buffName5[150];
		char buffName6[150];
		char command1[150];
		char command2[150];
		char command3[150];
		sprintf ( buffName1, "%s%04d", sensorPositionFile, updateNb );
		//cout <<"buffName1 = " <<buffName1 <<endl;

		sprintf ( buffName6, "%s%s", buffName1, ".g" );
		//cout <<"buffName6 = " <<buffName6 <<endl;

		sprintf ( buffName2, "%s%04d", point3DFile, updateNb );

		//cout <<"buffName2 = " <<buffName2 <<endl;

		sprintf ( buffName3, "%s%s", buffName2, ".gz" );

		//cout <<"buffName3 = " <<buffName3 <<endl;

		sprintf ( buffName4, "%s%04d", point3DFileTemp, updateNb );

		//cout <<"buffName4 = " <<buffName4 <<endl;

		sprintf ( buffName5, "%s%s", buffName4,".gz" );

		//cout <<"buffName5 = " <<buffName5 <<endl;

		sprintf ( command1, "%s%s%s%s", "cp ", buffName3," ", buffName5 );

		//cout <<"command1 = " <<command1 <<endl;

		sprintf ( command2, "%s%s", "gzip -df ",buffName5 );
		//cout <<"command2 = " <<command2 <<endl;

		sprintf ( command3, "%s%s", "rm -rf -r ",buffName4 );
		//cout <<"command3 = " <<command3 <<endl;

		//make a copy
		system ( command1 );
		system ( command2 );
//----------------------------------------------------setting sensor position
		float yaw1, pitch1 ,roll1, xx1 , yy1 , zz1;
		float yaw2, pitch2,roll2, xx2 , yy2 , zz2;
		float yaw3, pitch3,roll3, xx3 , yy3 , zz3;
		string lines[6],word1;
		char word2;

		ifstream myfile ( buffName6 );
		ODEBUG2 ( "Sensor file address : " << buffName6 );

		if ( myfile.is_open() )
		{
			unsigned int i = 0;
			while ( !myfile.eof() )
			{
				getline ( myfile,lines[i] );
				i++;
			}
		}

		myfile.close();
		istringstream stream;

		T3D inSensorPosition1 ( T3D_MATRIX,T3D_ALLOW_CONVERSION );
		T3D inSensorPosition2 ( T3D_MATRIX,T3D_ALLOW_CONVERSION );
		T3D cameraToSensor ( T3D_MATRIX,T3D_ALLOW_CONVERSION );
		T3D sensorToMain ( T3D_MATRIX,T3D_ALLOW_CONVERSION );
		T3D mainToOrigin ( T3D_MATRIX,T3D_ALLOW_CONVERSION );

		ODEBUG2 ( "cameraToSensorTest1 = " << cameraToSensor );

// using Robot Global Position
		ODEBUG2 ( "Setting Main to Origin (Robot Global Position)" );
		stream.str ( lines[4] );

		stream >>word1;
		stream >> word2;

		stream >> yaw1 >> pitch1 >> roll1 >> xx1 >> yy1 >> zz1;

		ODEBUG2 ( "yaw1 = " << yaw1 <<", pitch1= " << pitch1 << ", roll1= "<< roll1 <<",  xx1=  " << xx1 <<", yy1="<< yy1 <<", zz1= "<< zz1 );


		mainToOrigin.matrix ( 0,0 ) = cos ( yaw1 ) *cos ( pitch1 );
		mainToOrigin.matrix ( 0,1 ) = cos ( yaw1 ) *sin ( pitch1 ) *sin ( roll1 )-sin ( yaw1 ) *cos ( roll1 );
		mainToOrigin.matrix ( 0,2 ) = cos ( yaw1 ) *sin ( pitch1 ) *cos ( roll1 ) +sin ( yaw1 ) *sin ( roll1 );
		mainToOrigin.matrix ( 0,3 ) = xx1;
		mainToOrigin.matrix ( 1,0 ) = sin ( yaw1 ) *cos ( pitch1 );
		mainToOrigin.matrix ( 1,1 ) = sin ( yaw1 ) *sin ( pitch1 ) *sin ( roll1 ) +cos ( yaw1 ) *cos ( roll1 );
		mainToOrigin.matrix ( 1,2 ) = sin ( yaw1 ) *sin ( pitch1 ) *cos ( roll1 )-cos ( yaw1 ) *sin ( roll1 );
		mainToOrigin.matrix ( 1,3 ) = yy1;
		mainToOrigin.matrix ( 2,0 ) = -sin ( pitch1 );
		mainToOrigin.matrix ( 2,1 ) = cos ( pitch1 ) *sin ( roll1 );
		mainToOrigin.matrix ( 2,2 ) = cos ( pitch1 ) *cos ( roll1 );
		mainToOrigin.matrix ( 2,3 ) = zz1;
		mainToOrigin.matrix ( 3,0 ) =0;
		mainToOrigin.matrix ( 3,1 ) =0;
		mainToOrigin.matrix ( 3,2 ) =0;
		mainToOrigin.matrix ( 3,3 ) =1;

// 		mainToOrigin.bryan[0]=yaw1;
// 		mainToOrigin.bryan[1]=pitch1;
// 		mainToOrigin.bryan[2]=roll1;
// 		mainToOrigin.bryan[3]=xx1;
// 		mainToOrigin.bryan[4]=yy1;
// 		mainToOrigin.bryan[5]=zz1;
		if ( attwmGrid3D.setRobotBoxPos ( xx1, yy1, yaw1 ) !=WM_OK )
		{
			*report = S_worldModelGrid3DG_UPDATING_MAP_FAILURE;
			ODEBUG1 ( "Error: worldModelGrid-Genom:: UpdateMap: in setRobotBoxPos" );
			return FAIL;
		}

		ODEBUG2 ( "mainToOrigin_1 = " << mainToOrigin );

// using sensor Local Position
		ODEBUG2 ( "Setting sensor to main (Sensor Local Position)" );
		stream.str ( lines[2] );

		stream >>word1;
		stream >> word2;
		stream >> yaw2 >> pitch2 >> roll2 >> xx2 >> yy2 >> zz2;

		ODEBUG2 ( "yaw2 = " << yaw2 <<", pitch2= " << pitch2 << ", roll2= "<< roll2 <<",  xx2=  " << xx2 <<",yy2= "<< yy2 <<", zz= "<< zz2 );

		sensorToMain.matrix ( 0,0 ) =cos ( yaw2 ) *cos ( pitch2 );
		sensorToMain.matrix ( 0,1 ) =cos ( yaw2 ) *sin ( pitch2 ) *sin ( roll2 )-sin ( yaw2 ) *cos ( roll2 );
		sensorToMain.matrix ( 0,2 ) =cos ( yaw2 ) *sin ( pitch2 ) *cos ( roll2 ) +sin ( yaw2 ) *sin ( roll2 );
		sensorToMain.matrix ( 0,3 ) =xx2;
		sensorToMain.matrix ( 1,0 ) =sin ( yaw2 ) *cos ( pitch2 );
		sensorToMain.matrix ( 1,1 ) =sin ( yaw2 ) *sin ( pitch2 ) *sin ( roll2 ) +cos ( yaw2 ) *cos ( roll2 );
		sensorToMain.matrix ( 1,2 ) =sin ( yaw2 ) *sin ( pitch2 ) *cos ( roll2 )-cos ( yaw2 ) *sin ( roll2 );
		sensorToMain.matrix ( 1,3 ) =yy2;
		sensorToMain.matrix ( 2,0 ) =-sin ( pitch2 );
		sensorToMain.matrix ( 2,1 ) =cos ( pitch2 ) *sin ( roll2 );
		sensorToMain.matrix ( 2,2 ) =cos ( pitch2 ) *cos ( roll2 );
		sensorToMain.matrix ( 2,3 ) =zz2;
		sensorToMain.matrix ( 3,0 ) =0;
		sensorToMain.matrix ( 3,1 ) =0;
		sensorToMain.matrix ( 3,2 ) =0;
		sensorToMain.matrix ( 3,3 ) =1;

// 		sensorToMain.bryan[0]=yaw2;
// 		sensorToMain.bryan[1]=pitch2;
// 		sensorToMain.bryan[2]=roll2;
// 		sensorToMain.bryan[3]=xx2;
// 		sensorToMain.bryan[4]=yy2;
// 		sensorToMain.bryan[5]=zz2;
		ODEBUG2 ( "sensorToMain_1 = " << sensorToMain );

		yaw3 =-1* M_PI/2;
		pitch3 = 0;
		roll3 = -1*M_PI/2;
		xx3=0;
		yy3=0;
		zz3=0;

		cameraToSensor.matrix ( 0,0 ) =cos ( yaw3 ) *cos ( pitch3 );
		cameraToSensor.matrix ( 0,1 ) =cos ( yaw3 ) *sin ( pitch3 ) *sin ( roll3 )-sin ( yaw3 ) *cos ( roll3 );
		cameraToSensor.matrix ( 0,2 ) =cos ( yaw3 ) *sin ( pitch3 ) *cos ( roll3 ) +sin ( yaw3 ) *sin ( roll3 );
		cameraToSensor.matrix ( 0,3 ) =xx3;
		cameraToSensor.matrix ( 1,0 ) =sin ( yaw3 ) *cos ( pitch3 );
		cameraToSensor.matrix ( 1,1 ) =sin ( yaw3 ) *sin ( pitch3 ) *sin ( roll3 ) +cos ( yaw3 ) *cos ( roll3 );
		cameraToSensor.matrix ( 1,2 ) =sin ( yaw3 ) *sin ( pitch3 ) *cos ( roll3 )-cos ( yaw3 ) *sin ( roll3 );
		cameraToSensor.matrix ( 1,3 ) =yy3;
		cameraToSensor.matrix ( 2,0 ) =-sin ( pitch3 );
		cameraToSensor.matrix ( 2,1 ) =cos ( pitch3 ) *sin ( roll3 );
		cameraToSensor.matrix ( 2,2 ) =cos ( pitch3 ) *cos ( roll3 );
		cameraToSensor.matrix ( 2,3 ) =zz3;
		cameraToSensor.matrix ( 3,0 ) =0;
		cameraToSensor.matrix ( 3,1 ) =0;
		cameraToSensor.matrix ( 3,2 ) =0;
		cameraToSensor.matrix ( 3,3 ) =1;
// 		cameraToSensor.bryan[0]=M_PI/2;
// 		cameraToSensor.bryan[1]=0;
// 		cameraToSensor.bryan[2]=M_PI/2;
// 		cameraToSensor.bryan[3]=0;
// 		cameraToSensor.bryan[4]=0;
// 		cameraToSensor.bryan[5]=0;

		ODEBUG2 ( "cameraToSensorTest1 = " << cameraToSensor );
		inSensorPosition1 =  mainToOrigin*sensorToMain ;

		ODEBUG2 ( "mainToOrigin2 = " << mainToOrigin );
		ODEBUG1 ( "sensorToMain2 = " << sensorToMain );
		ODEBUG1 ( "sensor position1 = " << inSensorPosition1 );

		inSensorPosition2=inSensorPosition1 * cameraToSensor;
		ODEBUG2 ( "sensor position2 = " << inSensorPosition2 );

		if ( attwmGrid3D.setSensorPosition ( inSensorPosition2 ) !=WM_OK )
		{
			*report = S_worldModelGrid3DG_UPDATING_MAP_FAILURE;
			ODEBUG1 ( "Error: worldModelGrid-Genom:: UpdateMap: in SetSensorPosition" );
			return FAIL;
		}
// ------------------------------------------------setting range map and update map
		ODEBUG2 ( "start of WorldModelGrid3DGenom::updateMap(file) " );
		DATA_IM3D  inRangeMap;

		init_data_im3d ( &inRangeMap, 0, 0, 0, 0, 0 );

		ODEBUG2 ( "image3D file address : " << buffName4 );
		int aa=read_data_im3d_ascii ( &inRangeMap,buffName4 );
		ODEBUG2 ( "********** message = " << aa );

		if ( attwmGrid3D.setRangeMap ( &inRangeMap ) !=WM_OK )
		{
			*report = S_worldModelGrid3DG_UPDATING_MAP_FAILURE;
			cout << "Error: worldModelGrid-Genom:: UpdateMap: in setRangeMap" << endl;
			return FAIL;
		}
		ODEBUG2 ( " WorldModelGrid3DGenom::updateMap -> Range map was set" );

		if ( attwmGrid3D.updateMap () !=WM_OK )
		{
			*report = S_worldModelGrid3DG_UPDATING_MAP_FAILURE;
			ODEBUG1 ( "Error: worldModelGrid-Genom:: UpdateMap: in updateMap" );
			return FAIL;
		}

// to SET NULL attRangeMap in attwmGrid3D
		if ( attwmGrid3D.setRangeMap ( NULL ) !=WM_OK )
		{
			*report = S_worldModelGrid3DG_UPDATING_MAP_FAILURE;
			ODEBUG1 ( "Error: worldModelGrid-Genom:: UpdateMap: in setRangeMap" );
			return FAIL;
		}

		empty_data_im3d ( &inRangeMap );
		system ( command3 );
	}

#endif //end of using libimage3D
#endif // Test: For reading the pre-generated Textfile of stereopixel

	updateWorldModelPosters();
	return ETHER;
}

/*------------------------------------------------------------------------
 * ExportMap
 *
 * Description:
 *
 * Reports:      OK
 *              S_worldModelGrid3DG_EXPORTING_MAP_FAILURE
 */

/* worldModelGrid3DGExportMap  -  codel EXEC of ExportMap
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
worldModelGrid3DGExportMap ( fileNameAddress *exportDirectory, int *report )
{
	if ( SDI_F->updateFlag==1 )
		SDI_F->updateNumber++;
	SDI_F->updateFlag=0;

	char* path = SDI_F->exportDirectory.name;
	char mapEnv[250];
	sprintf ( mapEnv, "%s%s%03d%s", path,"/mapEnv", SDI_F->updateNumber,".txt" );
	std::string mapEnvPath= std::string ( mapEnv );
	//string mapEnvPath=string ( SDI_F->exportDirectory.name ) +string ( "/mapEnv1.txt" );

	if ( attwmGrid3D.exportOccupancyMap ( mapEnvPath ) != WM_OK )
	{
		*report = S_worldModelGrid3DG_EXPORTING_MAP_FAILURE;
		return FAIL;

	}
	return ETHER;
}

/*------------------------------------------------------------------------
 * ExportVRML
 *
 * Description:
 *
 * Reports:      OK
 *              S_worldModelGrid3DG_EXPORTING_VRML_MAP_FAILURE
 */

/* worldModelGrid3DGExportVRML  -  codel EXEC of ExportVRML
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
worldModelGrid3DGExportVRML ( exportSetting *setting, int *report )
{
	if ( SDI_F->updateFlag==1 )
		SDI_F->updateNumber++;
	SDI_F->updateFlag=0;

	char* path = SDI_F->setting.exportAddrees.name;
	char modelBuff[250];
	char solidBuff[250];
	char unknownBuff[250];
	sprintf ( modelBuff, "%s%s%03d%s", path,"/envModel", SDI_F->updateNumber,".wrl" );
	sprintf ( solidBuff, "%s%s%03d%s", path,"/envSolid", SDI_F->updateNumber,".wrl" );
	sprintf ( unknownBuff, "%s%s%03d%s", path,"/envUnknown", SDI_F->updateNumber,".wrl" );
	std::string modelPath= std::string ( modelBuff );
	std::string solidPath= std::string ( solidBuff );
	std::string unknownPath= std::string ( unknownBuff );

	if ( attwmGrid3D.exportVRML ( modelPath,solidPath,unknownPath, SDI_F->setting.exportMode ) != WM_OK )
	{
		*report = S_worldModelGrid3DG_EXPORTING_VRML_MAP_FAILURE;
		return FAIL;
	}
	return ETHER;
}
/*------------------------------------------------------------------------
 * SetRobotBoxPos
 *
 * Description:
 *
 * Reports:      OK
 *              S_worldModelGrid3DG_SET_ROBOT_POS_FAILURE
 */

/* worldModelGrid3DGSetRobotBoxPos  -  codel EXEC of SetRobotBoxPos
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
worldModelGrid3DGSetRobotBoxPos ( pos *robotPos, int *report )
{
	if ( attwmGrid3D.setRobotBoxPos ( robotPos->x, robotPos->y, robotPos->theta ) != WM_OK )
	{
		*report = S_worldModelGrid3DG_SET_ROBOT_POS_FAILURE;
		return FAIL;
	}
	return ETHER;
}

/*------------------------------------------------------------------------
 * SetRobotBoxFree
 *
 * Description:
 *
 * Reports:      OK
 *              S_worldModelGrid3DG_SET_ROBOT_BOX_FREE_FAILURE
 */

/* worldModelGrid3DGReSetRobotBoxFree  -  codel EXEC of SetRobotBoxFree
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
worldModelGrid3DGReSetRobotBoxFree ( int *report )
{
	if ( attwmGrid3D.setRobotBoxFree() != WM_OK )
	{
		*report = S_worldModelGrid3DG_SET_ROBOT_BOX_FREE_FAILURE;
		return FAIL;
	}
	updateWorldModelPosters();
	return ETHER;
}

/*------------------------------------------------------------------------
 * RefreshMap
 *
 * Description:
 *
 * Reports:      OK
 *              S_worldModelGrid3DG_Refresh_MAP_FAILURE
 */

/* worldModelGrid3DGRefreshMap  -  codel EXEC of RefreshMap
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
worldModelGrid3DGRefreshMap ( int *report )
{
	if ( attwmGrid3D.refreshMap() != WM_OK )
	{
		*report = S_worldModelGrid3DG_Refresh_MAP_FAILURE;
		return FAIL;

	}
	updateWorldModelPosters();
	return ETHER;
}


/*------------------------------------------------------------------------
 * ClearMap
 *
 * Description:
 *
 * Reports:      OK
 *              S_worldModelGrid3DG_CLEAR_MAP_FAILURE
 */

/* worldModelGrid3DGClearMap  -  codel EXEC of ClearMap
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
worldModelGrid3DGClearMap ( int *report )
{
	if ( attwmGrid3D.clearMap() != WM_OK )
	{
		*report = S_worldModelGrid3DG_CLEAR_MAP_FAILURE;
		return FAIL;

	}
	updateWorldModelPosters();

	return ETHER;
}

/*------------------------------------------------------------------------
 * ImportMap
 *
 * Description:
 *
 * Reports:      OK
 *              S_worldModelGrid3DG_IMPORT_MAP_FAILURE
 */

/* worldModelGrid3DGImportMap  -  codel EXEC of ImportMap
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
worldModelGrid3DGImportMap ( fileNameAddress *importFile, int *report )
{
	string importPathFile=string ( SDI_F->importFile.name );

	if ( attwmGrid3D.importMap ( importPathFile ) != WM_OK )
	{
		*report = S_worldModelGrid3DG_IMPORT_MAP_FAILURE;
		return FAIL;
	}
	updateWorldModelPosters();
	return ETHER;
}

